SegwayRMP400 Class Reference

SegwayRMP400 Position Driver. More...

`#include <segwayrmp400.h>`

Inheritance diagram for SegwayRMP400:

## Private Attributes

Device * | segwayrmp2d [2]
| child segwayrmp200 devices for 2d subsrciption
Device * | segwayrmp3d [2]
| child segwayrmp200 devices for 3d subsrciption
player_devaddr_t | segwayrmp2d_id [2]
| 2d Position Interface Address (Output)
player_devaddr_t | segwayrmp3d_id [2]
| 3d Position Interface Address (Output)
player_devaddr_t | position3d_id
| 3d Position Interface Address (Input)
player_devaddr_t | position2d_id
| 2d Position Interface Address (Input)
player_position2d_data_t | rmp2d_data [2]
| Incoming data from child segwayrmp200 devices 2d.
player_position3d_data_t | rmp3d_data [2]
| Incoming data from child segwayrmp200 devices 3d.
player_position2d_data_t | position2d_data
| Output data for parent segwayrmp400 device 2d.
player_position2d_cmd_vel_t | position2d_cmd
| Output cmd for parent segwayrmp400 device 2d.
player_position3d_data_t | position3d_data
| Output data for parent segwayrmp400 device 3d.
player_position3d_cmd_vel_t | position3d_cmd
| Output cmd for parent segwayrmp400 device 3d.
bool | provide_2d
| Provide 2d interface Flag.
bool | provide_3d
| Provide 3d interface Flag.
int | counter
bool | newfront3d
| Flags for new data.
bool | newback3d
bool | newfront2d
bool | newback2d
bool | fullspeed
| Flag for full speed data reporting.
| SegwayRMP400 (ConfigFile *cf, int section)
| Standard Constructor.
virtual int | MainSetup ()
| Initialize (Player Standard)
virtual void | MainQuit ()
| Shutdown (Player Standard)
void | Main ()
| Main.
int | ProcessMessage (QueuePointer &resp_queue, player_msghdr_t *hdr, void *data)
| Process message function (Player Standard)
void | ProcessData ()
| Packages position data and publishes. More...
int | HandlePosition3DCmd (player_position3d_cmd_vel_t *cmd)
| Internal method to handle position 3D commands.
int | HandlePosition2DCmd (player_position2d_cmd_vel_t *cmd)
| Internal method to handle position 2D commands.

## Additional Inherited Members

Public Member Functions inherited from ThreadedDriver
| ThreadedDriver (ConfigFile *cf, int section, bool overwrite_cmds, size_t queue_maxlen, int interf)
| Constructor with implicit interface. More...
| ThreadedDriver (ConfigFile *cf, int section, bool overwrite_cmds=true, size_t queue_maxlen=PLAYER_MSGQUEUE_DEFAULT_MAXLEN)
| Constructor for multiple-interface drivers. More...
virtual | ~ThreadedDriver ()
| Destructor.
virtual int | Setup ()
| Initialize the driver. More...
virtual int | Shutdown ()
| Finalize the driver. More...
virtual int | Terminate ()
| Terminate the driver. More...
bool | Wait (double TimeOut=0.0)
| Wait for new data to arrive on the driver's queue. More...
virtual void | Update ()
| Update non-threaded drivers. More...
Public Member Functions inherited from Driver
bool | HasSubscriptions ()
virtual void | Publish (player_devaddr_t addr, QueuePointer &queue, uint8_t type, uint8_t subtype, void *src=NULL, size_t deprecated=0, double *timestamp=NULL, bool copy=true)
| Publish a message via one of this driver's interfaces. More...
virtual void | Publish (player_devaddr_t addr, uint8_t type, uint8_t subtype, void *src=NULL, size_t deprecated=0, double *timestamp=NULL, bool copy=true)
| Publish a message via one of this driver's interfaces. More...
virtual void | Publish (QueuePointer &queue, player_msghdr_t *hdr, void *src, bool copy=true)
| Publish a message via one of this driver's interfaces. More...
virtual void | Publish (player_msghdr_t *hdr, void *src, bool copy=true)
| Publish a message via one of this driver's interfaces. More...
| Driver (ConfigFile *cf, int section, bool overwrite_cmds, size_t queue_maxlen, int interf)
| Constructor for single-interface drivers. More...
| Driver (ConfigFile *cf, int section, bool overwrite_cmds=true, size_t queue_maxlen=PLAYER_MSGQUEUE_DEFAULT_MAXLEN)
| Constructor for multiple-interface drivers. More...
virtual | ~Driver ()
| Destructor.
int | GetError ()
| Get last error value. More...
virtual int | Subscribe (player_devaddr_t addr)
| Subscribe to this driver. More...
virtual int | Subscribe (QueuePointer &queue, player_devaddr_t addr)
| Subscribe to this driver. More...
virtual int | Unsubscribe (player_devaddr_t addr)
| Unsubscribe from this driver. More...
virtual int | Unsubscribe (QueuePointer &queue, player_devaddr_t addr)
| Unsubscribe from this driver. More...
void | ProcessMessages (int maxmsgs)
| Process pending messages. More...
void | ProcessMessages (void)
| Process pending messages. More...
virtual int | ProcessInternalMessages (QueuePointer &resp_queue, player_msghdr *hdr, void *data)
| Internal message handler. More...
virtual bool | RegisterProperty (const char *key, Property *prop, ConfigFile *cf, int section)
| Property registration. More...
virtual bool | RegisterProperty (Property *prop, ConfigFile *cf, int section)
| Property registration. More...
Public Attributes inherited from Driver
QueuePointer | ret_queue
| Last requester's queue. More...
player_devaddr_t | device_addr
| Default device address (single-interface drivers)
int | entries
| Total number of entries in the device table using this driver. More...
bool | alwayson
| Always on flag. More...
QueuePointer | InQueue
| Queue for all incoming messages for this driver.
Protected Member Functions inherited from ThreadedDriver
virtual void | StartThread (void)
virtual void | StopThread (void)
| Cancel (and wait for termination) of the driver thread. More...
void | TestCancel ()
| enable thread cancellation and test for cancellation More...
Protected Member Functions inherited from Driver
int | AddInterface (player_devaddr_t addr)
| Add an interface. More...
int | AddInterface (player_devaddr_t *addr, ConfigFile *cf, int section, int code, const char *key=NULL)
| Add an interface. More...
void | SetError (int code)
| Set/reset error code.
int | AddFileWatch (int fd, bool ReadWatch=true, bool WriteWatch=false, bool ExceptWatch=true)
| Wake up the driver if the specified event occurs on the file descriptor.
int | RemoveFileWatch (int fd, bool ReadWatch=true, bool WriteWatch=false, bool ExceptWatch=true)
| Remove a previously added watch, call with the same arguments as when adding the watch.
virtual void | Lock (void)
| Lock access between the server and driver threads. More...
virtual void | Unlock (void)
| Unlock access to driver internals. More...
virtual void | SubscriptionLock (void)
| Lock to protect the subscription count for the driver.
virtual void | SubscriptionUnlock (void)
| Unlock to protect the subscription count for the driver. More...
Static Protected Member Functions inherited from ThreadedDriver
static void * | DummyMain (void *driver)
| Dummy main (just calls real main). More...
static void | DummyMainQuit (void *driver)
| Dummy main cleanup (just calls real main cleanup). More...

## Detailed Description

SegwayRMP400 Position Driver.

## Member Function Documentation

void SegwayRMP400::ProcessData | ( |  | ) |

private

Packages position data and publishes.

Todo:
  Add smarter approach to combine the data from both RMPs. For now, just average.

References fullspeed, newfront3d, player_pose2d::pa, PLAYER_MSGTYPE_DATA, PLAYER_POSITION2D_DATA_STATE, PLAYER_POSITION3D_DATA_STATE, player_position2d_data::pos, player_position3d_data::pos, position2d_data, position2d_id, position3d_data, position3d_id, player_pose3d::ppitch, player_pose3d::proll, Driver::Publish(), player_pose2d::px, player_pose3d::px, player_pose2d::py, player_pose3d::py, player_pose3d::pyaw, player_pose3d::pz, rmp2d_data, rmp3d_data, player_position2d_data::vel, and player_position3d_data::vel.

Referenced by Main().

The documentation for this class was generated from the following files:

- segwayrmp400.h
- segwayrmp400.cc

Last updated 12 September 2005 21:38:45